%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Ce script Matlab gnre un graphe alatoire binomial   
%%% avec n sommets selon le modle d'Erds 
%%%
%%% Voir l'exercice VII du TD1 de "Systme Robotiques Htrognes et Coopratifs" 2020-2021
%%%
%%% Auteur: Fabio Morbidi
%%% Avril 2012

clear
close all
clc

%% Paramtres du graphe alatoire %%

n = 25;   %% Nombre de sommets du graphe

p = 0.05; %% Probabilit d'avoir une arte entre deux sommets

video = 0; %% Si video = 1, une animation est gnre
           %% Si video = 0, aucune animation est gnre 

%% La position des sommets du graphe est gnre de faon alatoire 
%% dans le carr [a, b] x [a, b] (distribution uniforme)                      
                       
a = -1; 
b = 1;

x = a + (b-a).*rand(n,1); %% Coordonnes x des sommets
y = a + (b-a).*rand(n,1); %% Coordonnes y des sommets

%%%%%%%%%%%%%%%%%

if video == 0
                      
%% Gnration de la matrice d'adjacence du graphe alatoire 

M = rand(n,n) < p; %% Les lments de M sont tirs d'une distribution uniforme standard dans l'intervalle ouverte (0, 1)
Mu = triu(M,1);    %% "Symtrisation" de M (on extrait la partie triangulaire suprieure de M)
A = Mu + Mu';      %% Matrice d'adjacence du graphe alatoire

%%% Affichage du graphe alatoire %%%

figure(1)
hold on
   
for i=1:n
   for j=1:n
       if A(i,j)==1
          line([x(i),x(j)],[y(i),y(j)],'color','k') %% Les artes du graphe alatoire sont traces 
       end
   end 
end

plot(x,y,'r.','MarkerSize',25) %% Les sommets du graphe alatoire sont dessins 

title(sprintf('Graphe alatoire binomial avec :  n = %g,  p = %g',n,p))
xlabel('x')
ylabel('y')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% L'animation montre comment le graphe alatoire volue pour p qui varie
%%% entre 0 et 1 avec un pas q. Le nombre n de sommets est fixe 

else

q = 0.05; %% Taille du pas    
    
figure(1)
hold on
for p = 0:q:1
    M = rand(n,n) < p; 
    Mu = triu(M,1); 
    A = Mu + Mu'; %% Matrice d'adjacence du graphe alatoire
    for i=1:n
        for j=1:n
            if A(i,j)==1
               line([x(i),x(j)],[y(i),y(j)],'color','k') %% Les artes du graphe alatoire sont traces
            end
        end 
    end
    hold on
    plot(x,y,'r.','MarkerSize',25) %% Les sommets du graphe alatoire sont dessins
    xlabel('x')
    ylabel('y')
    title(sprintf('Graphe alatoire binomial avec :  n = %g,  p = %g',n,p))
    pause(0.75)
    if p ~= 1
       clf
    end
end

end

%% EXERCICE: Vrifier numriquement les deux proprits suivantes:
%%
%% La thorie des graphes de Erds-Reyni, nous dit que: 
%% 1) Une composante connexe "gante" devrait apparatre pour p > 1/(n-1) 
%% 2) Le graphe est cens devenir completement connexe quand p est proche de log(n)/n
